<template>
  <div class="w-100">
    <div class="my-4">
      <h4 class="mt-0">Welcome back</h4>
    </div>

    <form @submit.prevent="login">
      <div id="error-message" v-if="errors.serverSideErrorMessage">
        <span>
          {{ errors.serverSideErrorMessage }}
        </span>
      </div>

      <div class="form-group mb-3">
        <label for="email">E-mail addresse</label>
        <input
          class="form-control"
          type="email"
          id="email"
          required
          v-model="credentials.email"
          placeholder="E-mail addresse"
        />
      </div>

      <div class="form-group mb-3">
        <label for="password">Password</label>
        <input
          class="form-control"
          type="password"
          required
          id="password"
          v-model="credentials.password"
          placeholder="Password"
        />
      </div>

      <div class="form-group mb-3">
        <router-link :to="{ name: 'ForgotPassword' }" class="text-muted ml-1"
          >Forgot password?</router-link
        >
      </div>

      <div class="form-group mb-0 text-center">
        <button
          class="btn btn-primary btn-submit w-100"
          type="submit"
          :disabled="submitting"
        >
          Login
        </button>
      </div>
    </form>
  </div>
</template>

<script>
export default {
  name: "login-page",
  data: () => ({
    submitting: false,
    credentials: {
      email: null,
      password: null,
    },
    errors: {
      serverSideErrorMessage: null,
    },
  }),
  methods: {
    clearErrorsMessages() {
      this.errors.serverSideErrorMessage = null;
    },
    clearForm() {
      this.credentials.email = null;
      this.credentials.password = null;
    },
    async login() {
      this.clearErrorsMessages();

      this.submitting = true;
      this.$services.AuthService.login(this.credentials)
        .then(() => {
          this.getCurrentAdmin();
        })
        .catch((err) => {
          if (err.response.status === 403) {
            this.errors.serverSideErrorMessage = err.response.data.message;
          } else {
            this.errors.serverSideErrorMessage =
              "Something went wrong. Please try again later!";
          }
          this.submitting = false;
        });
    },
    async getCurrentAdmin() {
      this.$store
        .dispatch("admin/fetchCurrentAdmin", this.$services)
        .then(() => {
          this.$router.push({ name: "DashboardHome" });
        })
        .catch((err) => {
          console.log(err);
          this.errorMessage = "Something went wrong. Please try again later!";
          this.laoding = false;
        });
    },
  },
};
</script>

<style>
</style>